import { computed as y, ref as i, watch as V, onMounted as ve, onBeforeUnmount as he, createElementBlock as c, openBlock as s, unref as n, normalizeStyle as A, createBlock as C, createCommentVNode as h, createSlots as de, withCtx as _, renderSlot as f, normalizeProps as F, guardReactiveProps as S, normalizeClass as z, createVNode as ye, Fragment as J, renderList as K, toDisplayString as fe } from "vue";
import { u as pe, c as ge, a as me, o as ke, e as we, w as Q, m as be, X as Ce, i as _e, v as Z, f as Oe } from "./index-B9qF6XbP.js";
import { _ as $e } from "./Title-D6h1gTvZ.js";
import { u as xe, U as Ie } from "./usePrinter-DsiBLAy1.js";
import { t as Pe, u as Ae } from "./useResponsive-BWapHhVH.js";
import Fe from "./vue-ui-skeleton-CHEZlRpn.js";
import { u as ee } from "./useNestedProp-g5oKzlVy.js";
import { _ as Se } from "./PackageVersion-DqmHcoqz.js";
import { P as ze } from "./PenAndPaper-6UYizrkQ.js";
import { u as Me } from "./useUserOptionState-BIvW1Kz7.js";
import { _ as Te } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ne = ["id"], Ue = ["xmlns", "viewBox"], Xe = ["width", "height"], Le = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-linecap"], Be = ["d", "fill"], Ee = ["cx", "cy", "r", "stroke", "stroke-width"], Ge = ["x", "y", "font-size", "fill", "font-weight"], Re = {
  key: 5,
  class: "vue-data-ui-watermark"
}, je = {
  __name: "vue-ui-wheel",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(te, { expose: ae }) {
    const { vue_ui_wheel: le } = pe(), d = te, O = y(() => !!d.dataset && Object.keys(d.dataset).length), $ = i(ge()), oe = i(null), M = i(0), p = i(null), T = i(null), N = i(null), U = i(null), X = i(0), e = y({
      get: () => E(),
      set: (t) => t
    }), { userOptionsVisible: x, setUserOptionsVisibility: L, keepUserOptionState: B } = Me({ config: e.value });
    function E() {
      const t = ee({
        userConfig: d.config,
        defaultConfig: le
      });
      return t.theme ? {
        ...ee({
          userConfig: me.vue_ui_wheel[t.theme] || d.config,
          defaultConfig: t
        })
      } : t;
    }
    V(() => d.config, (t) => {
      e.value = E(), x.value = !e.value.userOptions.showOnChartHover, H(), X.value += 1;
    }, { deep: !0 });
    const { isPrinting: G, isImaging: R, generatePdf: j, generateImage: D } = xe({
      elementId: $.value,
      fileName: e.value.style.chart.title.text || "vue-ui-wheel"
    }), ne = y(() => e.value.userOptions.show && !e.value.style.chart.title.text), l = i({
      size: 360,
      height: 360,
      width: 360
    }), I = i(e.value.style.chart.layout.percentage.fontSize), r = y(() => ({
      radius: Math.min(l.value.width, l.value.height) * 0.9 / 2,
      centerX: l.value.width / 2,
      centerY: l.value.height / 2
    }));
    function Y(t, o = 1) {
      return {
        x: r.value.centerX + r.value.radius * Math.cos(29.85 + t * Math.PI / 180) * o,
        y: r.value.centerY + r.value.radius * Math.sin(29.85 + t * Math.PI / 180) * o
      };
    }
    const u = i(e.value.style.chart.animation.use ? 0 : d.dataset.percentage || 0);
    V(() => d.dataset, (t) => {
      e.value.style.chart.animation.use ? W(t.percentage) : u.value = t.percentage || 0;
    }, { deep: !0 });
    const m = i(null);
    ve(() => {
      H();
    });
    function H() {
      if (ke(d.dataset) && we({
        componentName: "VueUiWheel",
        type: "dataset"
      }), W(d.dataset.percentage || 0), e.value.responsive) {
        const t = Pe(() => {
          const { width: o, height: a } = Ae({
            chart: p.value,
            title: e.value.style.chart.title.text ? T.value : null,
            source: N.value,
            noTitle: U.value
          });
          requestAnimationFrame(() => {
            l.value.width = o, l.value.height = a, I.value = e.value.style.chart.layout.percentage.fontSize / 360 * Math.min(o, a);
          });
        });
        m.value = new ResizeObserver(t), m.value.observe(p.value.parentNode);
      }
    }
    he(() => {
      m.value && m.value.disconnect();
    });
    function W(t) {
      let o = e.value.style.chart.animation.speed;
      const a = Math.abs(t - u.value) / (o * 120);
      function v() {
        u.value < t ? u.value = Math.min(u.value + a, t) : u.value > t && (u.value = Math.max(u.value - a, t)), u.value !== t && requestAnimationFrame(v);
      }
      v();
    }
    const g = y(() => Math.max(100, e.value.style.chart.layout.wheel.ticks.quantity)), k = y(() => 100 / g.value), q = y(() => {
      const t = [];
      for (let o = 0; o < g.value; o += 1) {
        const a = u.value > o * k.value ? e.value.style.chart.layout.wheel.ticks.activeColor : e.value.style.chart.layout.wheel.ticks.inactiveColor, { x: v, y: ue } = Y(l.value.size / g.value * o), { x: ie, y: ce } = Y(l.value.size / g.value * o, e.value.style.chart.layout.wheel.ticks.sizeRatio);
        t.push({
          x1: v,
          y1: ue,
          x2: ie,
          y2: ce,
          color: e.value.style.chart.layout.wheel.ticks.gradient.show ? Q(a, o * k.value / g.value * (e.value.style.chart.layout.wheel.ticks.gradient.shiftHueIntensity / 100)) : a
        });
      }
      return t;
    }), se = y(() => be({ series: q.value.map((t) => ({
      name: "",
      value: 1,
      color: t.color
    })) }, r.value.centerX, r.value.centerY, r.value.radius, r.value.radius, 1.99999, 2, 1, 360, 105.25, r.value.radius * (1 - e.value.style.chart.layout.wheel.ticks.sizeRatio))), w = i(!1);
    function re(t) {
      w.value = t, M.value += 1;
    }
    const b = i(!1);
    function P() {
      b.value = !b.value;
    }
    return ae({
      generatePdf: j,
      generateImage: D,
      toggleAnnotator: P
    }), (t, o) => (s(), c("div", {
      class: "vue-ui-wheel",
      ref_key: "wheelChart",
      ref: p,
      id: $.value,
      style: A(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height:100%" : ""}`),
      onMouseenter: o[0] || (o[0] = () => n(L)(!0)),
      onMouseleave: o[1] || (o[1] = () => n(L)(!1))
    }, [
      e.value.userOptions.buttons.annotator ? (s(), C(ze, {
        key: 0,
        parent: p.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: b.value,
        onClose: P
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : h("", !0),
      ne.value ? (s(), c("div", {
        key: 1,
        ref_key: "noTitle",
        ref: U,
        class: "vue-data-ui-no-title-space",
        style: "height:36px; width: 100%;background:transparent"
      }, null, 512)) : h("", !0),
      e.value.style.chart.title.text ? (s(), c("div", {
        key: 2,
        ref_key: "chartTitle",
        ref: T,
        style: "width:100%;background:transparent;padding-bottom:12px"
      }, [
        (s(), C($e, {
          key: `title_${X.value}`,
          config: {
            title: {
              cy: "wheel-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "wheel-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : h("", !0),
      e.value.userOptions.show && O.value && (n(B) || n(x)) ? (s(), C(Ie, {
        ref_key: "details",
        ref: oe,
        key: `user_options_${M.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: n(G),
        isImaging: n(R),
        uid: $.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        hasXls: !1,
        isFullscreen: w.value,
        position: e.value.userOptions.position,
        titles: { ...e.value.userOptions.buttonTitles },
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: b.value,
        chartElement: p.value,
        onToggleFullscreen: re,
        onGeneratePdf: n(j),
        onGenerateImage: n(D),
        onToggleAnnotator: P,
        style: A({
          visibility: n(B) ? n(x) ? "visible" : "hidden" : "visible"
        })
      }, de({ _: 2 }, [
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: _(() => [
            f(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: _(() => [
            f(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: _(({ toggleFullscreen: a, isFullscreen: v }) => [
            f(t.$slots, "optionFullscreen", F(S({ toggleFullscreen: a, isFullscreen: v })), void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: _(({ toggleAnnotator: a, isAnnotator: v }) => [
            f(t.$slots, "optionAnnotator", F(S({ toggleAnnotator: a, isAnnotator: v })), void 0, !0)
          ]),
          key: "3"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasImg", "hasFullscreen", "isFullscreen", "position", "titles", "hasAnnotator", "isAnnotation", "chartElement", "onGeneratePdf", "onGenerateImage", "style"])) : h("", !0),
      O.value ? (s(), c("svg", {
        key: 4,
        xmlns: n(Ce),
        class: z({ "vue-data-ui-fullscreen--on": w.value, "vue-data-ui-fulscreen--off": !w.value }),
        viewBox: `0 0 ${l.value.width <= 0 ? 10 : l.value.width} ${l.value.height <= 0 ? 10 : l.value.height}`,
        style: A(`max-width:100%;overflow:visible;background:transparent;color:${e.value.style.chart.color}`)
      }, [
        ye(Se),
        t.$slots["chart-background"] ? (s(), c("foreignObject", {
          key: 0,
          x: 0,
          y: 0,
          width: l.value.width <= 0 ? 10 : l.value.width,
          height: l.value.height <= 0 ? 10 : l.value.height,
          style: {
            pointerEvents: "none"
          }
        }, [
          f(t.$slots, "chart-background", {}, void 0, !0)
        ], 8, Xe)) : h("", !0),
        e.value.style.chart.layout.wheel.ticks.type === "classic" ? (s(!0), c(J, { key: 1 }, K(q.value, (a, v) => (s(), c("line", {
          x1: a.x1,
          x2: a.x2,
          y1: a.y1,
          y2: a.y2,
          stroke: a.color,
          "stroke-width": e.value.style.chart.layout.wheel.ticks.strokeWidth / 360 * Math.min(l.value.width, l.value.height),
          "stroke-linecap": e.value.style.chart.layout.wheel.ticks.rounded ? "round" : "butt",
          class: z({ "vue-ui-tick-animated": e.value.style.chart.animation.use && v * k.value <= u.value })
        }, null, 10, Le))), 256)) : (s(!0), c(J, { key: 2 }, K(se.value, (a, v) => (s(), c("path", {
          d: a.arcSlice,
          fill: a.color,
          class: z({ "vue-ui-tick-animated": e.value.style.chart.animation.use && v * k.value <= u.value })
        }, null, 10, Be))), 256)),
        e.value.style.chart.layout.innerCircle.show ? (s(), c("circle", {
          key: 3,
          cx: r.value.centerX,
          cy: r.value.centerY,
          r: r.value.radius * 0.8 <= 0 ? 1e-4 : r.value.radius * 0.8,
          stroke: e.value.style.chart.layout.innerCircle.stroke,
          "stroke-width": e.value.style.chart.layout.innerCircle.strokeWidth,
          fill: "none"
        }, null, 8, Ee)) : h("", !0),
        e.value.style.chart.layout.percentage.show ? (s(), c("text", {
          key: 4,
          x: r.value.centerX,
          y: r.value.centerY + I.value / 3,
          "font-size": I.value,
          fill: e.value.style.chart.layout.wheel.ticks.gradient.show ? n(Q)(e.value.style.chart.layout.wheel.ticks.activeColor, u.value / 100 * (e.value.style.chart.layout.wheel.ticks.gradient.shiftHueIntensity / 100)) : e.value.style.chart.layout.wheel.ticks.activeColor,
          "text-anchor": "middle",
          "font-weight": e.value.style.chart.layout.percentage.bold ? "bold" : "normal",
          style: { "font-variant-numeric": "tabluar-nums" }
        }, fe(n(_e)(
          e.value.style.chart.layout.percentage.formatter,
          n(Z)(u.value),
          n(Oe)({
            v: n(Z)(u.value),
            s: "%",
            r: e.value.style.chart.layout.percentage.rounding
          })
        )), 9, Ge)) : h("", !0),
        f(t.$slots, "svg", { svg: l.value }, void 0, !0)
      ], 14, Ue)) : h("", !0),
      t.$slots.watermark ? (s(), c("div", Re, [
        f(t.$slots, "watermark", F(S({ isPrinting: n(G) || n(R) })), void 0, !0)
      ])) : h("", !0),
      t.$slots.source ? (s(), c("div", {
        key: 6,
        ref_key: "source",
        ref: N,
        dir: "auto"
      }, [
        f(t.$slots, "source", {}, void 0, !0)
      ], 512)) : h("", !0),
      O.value ? h("", !0) : (s(), C(Fe, {
        key: 7,
        config: {
          type: "wheel",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            wheel: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"]))
    ], 44, Ne));
  }
}, tt = /* @__PURE__ */ Te(je, [["__scopeId", "data-v-c9c35e28"]]);
export {
  tt as default
};
